/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006      by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: target_config.c 8 2006-10-29 12:01:12Z asp $
 */

/*
 *		åȰ¸⥸塼M3A-ZA36ѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "target_syssvc.h"

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  ץå¸ν
	 */
	prc_initialize();

	/*
	 *  ХʡϤΤSIO٥륷ꥢϡ
	 */
	sil_wrb_mem((void *)(SIOCR(TARGET_PUTC_PORTID-1)+3), 0);

	/* ݡȤ򳫤(UART0) */
	sil_wrb_mem((void *)PDATA(5), 0);
	sil_wrb_mem((void *)PDIR(5), 0x80);

	/* UART, Non-parity, 1 stop-bit */
	sil_wrb_mem((void *)(SIOMOD0(TARGET_PUTC_PORTID-1)+3), 0);

	/* 8bit, internal clock */
	sil_wrh_mem((void *)(SIOMOD1(TARGET_PUTC_PORTID-1)+2), 0x0800);

	/* OAKS32R BCLK/PCLK:66MHz115200bps */
	sil_wrh_mem((void *)(SIOBAUR(TARGET_PUTC_PORTID-1)+2), SERIAL_CLKDIV);
	sil_wrb_mem((void *)(SIORBAUR(TARGET_PUTC_PORTID-1)+3), SERIAL_CLKCMP);
		
	/* ơꥢ, ư */
	sil_wrb_mem((void *)(SIOCR(TARGET_PUTC_PORTID-1)+2), 0x3);
	sil_wrb_mem((void *)(SIOCR(TARGET_PUTC_PORTID-1)+3), 0x3);

	/* TxD,RxDԥͭ(UART0) */
	sil_wrh_mem((void *)PMOD(5), 0x5500);
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *  ץå¸νλ
	 */
	prc_terminate();

	while (1);
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		target_fput_log('\r');
	}
	while((sil_reb_mem((void *)(SIOSTS(TARGET_PUTC_PORTID-1)+3)) & 0x1) == 0);	
	sil_wrb_mem((void *)(SIOTXB(TARGET_PUTC_PORTID-1)+3), c);
}

